Index: /main/trunk/greenstone3/resources/oai/OAIConfig.xml.in
===================================================================
--- /main/trunk/greenstone3/resources/oai/OAIConfig.xml.in	(revision 28903)
+++ /main/trunk/greenstone3/resources/oai/OAIConfig.xml.in	(revision 28903)
@@ -0,0 +1,80 @@
+<!--
+    This is the configuration file for the OAI server. The property values in this file are repository-wise
+-->
+<OAIConfig>       
+  <!-- The name of this oai repository, which is human readable. -->
+  <repositoryName>Greenstone3 OAI repository</repositoryName>
+  <!-- The unique id of this repository - if using version 2.0 should correspond to your domaine name -->
+  <repositoryIdentifier></repositoryIdentifier>
+  <!-- The base url to request metadata from this repository.
+  TODO: this element should be determined and overriden dynamically given the osi request url in OAIServer.java. 
+    WHAT'S DONE: when ant start is called, it writes out the default oaiserver URL to this file. -->
+  <baseURL>http://your-domain-name/greenstone3/oaiserver</baseURL>
+  <!-- The version of OAI specification this repository supports. Can be 2.0 or 1.0 -->
+  <protocolVersion>2.0</protocolVersion>
+  <!-- A UTC date time that is the guaranteed lower limit of all datestamps recording changes, midifications etc. in the repository
+  This element is not necessary in this file since the earliest datestamp is dynamically found out by searching thru all oai collections in the repository to get the earliest built time amongst the collections. This will be used if the 
+  collections all have 0 earliest datestamp, or if there are no collections. -->
+  <earliestDatestamp>1970-01-01</earliestDatestamp>
+  <!-- The manner in which the repository supports the notion of deleted records -->
+  <deletedRecord>no</deletedRecord>
+  <!-- The granularity of the datestamp -->
+  <granularity>YYYY-MM-DDThh:mm:ssZ</granularity>
+  <!-- The repository maintainer email address. There can be more than one. -->
+  <adminEmail></adminEmail>
+  <!-- Metadata describing the repository. Any metadata can go here -->
+  <oaiInfo>
+    <!-- <metadata name="meta-name">meta-value</metadata>-->
+  </oaiInfo>
+  <!-- Information above this line goes into the response to the Identify request -->
+  <!-- OAI super sets. This exposes a group of collections as a single OAI set.
+  Copy and fill in the values for each super set you want. This sets up a super set, then each collection for this super set must state in its OAIPMH service element that it belongs to the super set (<oaiSuperSet name="xxx"/> where xxx is the setSpec)-->
+<!--  <oaiSuperSet>
+    <setSpec>oai set identifier</setSpec>
+    <setName>Human readable set name</setName>
+    <setDescription>Set description</setDescription>
+  </oaiSuperSet>-->
+
+  <!-- set the following to no if you don't want a stylesheet to be specified in the OAI output -->
+  <useOAIStylesheet>yes</useOAIStylesheet>
+  <!-- uncomment and set value if you want to use a different stylesheet to the default interfaces/oai/oai2.xsl -->
+  <!--<OAIStylesheet></OAIStylesheet> -->
+  
+  <!-- The time period in which a newly generated resumption token will remain valid, specified in second. Hence, the default
+  value 7200 is equivalent to 2 hours.        
+  If the resumeAfter parameter is less than 0, this value will not be used.
+  -->
+  <resumptionTokenExpiration>7200</resumptionTokenExpiration>
+  <!-- How many sets/identifiers/records to send for the request before issuing a resumption token. A value less than 0 (e.g. -1) indicates that a complete list of records will be returned. -->
+  <resumeAfter>250</resumeAfter>
+  <!-- a list of metadata formats supported by this repository -->
+  <ListMetadataFormats>
+    <metadataFormat metadataPrefix="oai_dc">
+      <metadataPrefix>oai_dc</metadataPrefix>
+      <schema>http://www.openarchives.org/OAI/2.0/oai_dc.xsd</schema>
+      <metadataNamespace>http://www.openarchives.org/OAI/2.0/oai_dc/</metadataNamespace>
+      <mappingList>
+        <!-- 
+        This is the default mapping for dc metadata. It can be overridden for a collection by adding a mappingList into the oai_dc metadataFormat element in the collection's collectionConfig.xml file.
+        The mapping is in the form: <publicly supported metadata name>,<greenstone metadata name>, (<A>,<B>). B metadata from a document will be mapped to A. 
+        The first metadata name is mandatory; if there is no greenstone name following, then the first name will be looked for in the documents. 
+        -->
+	<mapping>dc:title,dc.Title</mapping>
+	<mapping>dc:creator,dc.Creator</mapping>
+	<mapping>dc:subject,dc.Subject</mapping>
+	<mapping>dc:description,dc.Description</mapping>
+	<mapping>dc:publisher,dc.Publisher</mapping>
+	<mapping>dc:contributor,dc.Contributor</mapping>
+	<mapping>dc:date,dc.Date</mapping>
+	<mapping>dc:type,dc.Type</mapping>
+	<mapping>dc:format,dc.Format</mapping>
+	<mapping>dc:identifier,dc.Identifier</mapping>
+	<mapping>dc:source,dc.Source</mapping>
+	<mapping>dc:language,dc.Language</mapping>
+	<mapping>dc:relation,dc.Relation</mapping>
+	<mapping>dc:coverage,dc.Coverage</mapping>
+	<mapping>dc:rights,dc.Rights</mapping>
+      </mappingList>
+    </metadataFormat>
+  </ListMetadataFormats>
+</OAIConfig>
Index: in/trunk/greenstone3/web/WEB-INF/classes/OAIConfig.xml.in
===================================================================
--- /main/trunk/greenstone3/web/WEB-INF/classes/OAIConfig.xml.in	(revision 28902)
+++ 	(revision )
@@ -1,80 +1,0 @@
-<!--
-    This is the configuration file for the OAI server. The property values in this file are repository-wise
--->
-<OAIConfig>       
-  <!-- The name of this oai repository, which is human readable. -->
-  <repositoryName>Greenstone3 OAI repository</repositoryName>
-  <!-- The unique id of this repository - if using version 2.0 should correspond to your domaine name -->
-  <repositoryIdentifier></repositoryIdentifier>
-  <!-- The base url to request metadata from this repository.
-  TODO: this element should be determined and overriden dynamically given the osi request url in OAIServer.java. 
-    WHAT'S DONE: when ant start is called, it writes out the default oaiserver URL to this file. -->
-  <baseURL>http://your-domain-name/greenstone3/oaiserver</baseURL>
-  <!-- The version of OAI specification this repository supports. Can be 2.0 or 1.0 -->
-  <protocolVersion>2.0</protocolVersion>
-  <!-- A UTC date time that is the guaranteed lower limit of all datestamps recording changes, midifications etc. in the repository
-  This element is not necessary in this file since the earliest datestamp is dynamically found out by searching thru all oai collections in the repository to get the earliest built time amongst the collections. This will be used if the 
-  collections all have 0 earliest datestamp, or if there are no collections. -->
-  <earliestDatestamp>1970-01-01</earliestDatestamp>
-  <!-- The manner in which the repository supports the notion of deleted records -->
-  <deletedRecord>no</deletedRecord>
-  <!-- The granularity of the datestamp -->
-  <granularity>YYYY-MM-DDThh:mm:ssZ</granularity>
-  <!-- The repository maintainer email address. There can be more than one. -->
-  <adminEmail></adminEmail>
-  <!-- Metadata describing the repository. Any metadata can go here -->
-  <oaiInfo>
-    <!-- <metadata name="meta-name">meta-value</metadata>-->
-  </oaiInfo>
-  <!-- Information above this line goes into the response to the Identify request -->
-  <!-- OAI super sets. This exposes a group of collections as a single OAI set.
-  Copy and fill in the values for each super set you want. This sets up a super set, then each collection for this super set must state in its OAIPMH service element that it belongs to the super set (<oaiSuperSet name="xxx"/> where xxx is the setSpec)-->
-<!--  <oaiSuperSet>
-    <setSpec>oai set identifier</setSpec>
-    <setName>Human readable set name</setName>
-    <setDescription>Set description</setDescription>
-  </oaiSuperSet>-->
-
-  <!-- set the following to no if you don't want a stylesheet to be specified in the OAI output -->
-  <useOAIStylesheet>yes</useOAIStylesheet>
-  <!-- uncomment and set value if you want to use a different stylesheet to the default interfaces/oai/oai2.xsl -->
-  <!--<OAIStylesheet></OAIStylesheet> -->
-  
-  <!-- The time period in which a newly generated resumption token will remain valid, specified in second. Hence, the default
-  value 7200 is equivalent to 2 hours.        
-  If the resumeAfter parameter is less than 0, this value will not be used.
-  -->
-  <resumptionTokenExpiration>7200</resumptionTokenExpiration>
-  <!-- How many sets/identifiers/records to send for the request before issuing a resumption token. A value less than 0 (e.g. -1) indicates that a complete list of records will be returned. -->
-  <resumeAfter>250</resumeAfter>
-  <!-- a list of metadata formats supported by this repository -->
-  <ListMetadataFormats>
-    <metadataFormat metadataPrefix="oai_dc">
-      <metadataPrefix>oai_dc</metadataPrefix>
-      <schema>http://www.openarchives.org/OAI/2.0/oai_dc.xsd</schema>
-      <metadataNamespace>http://www.openarchives.org/OAI/2.0/oai_dc/</metadataNamespace>
-      <mappingList>
-        <!-- 
-        This is the default mapping for dc metadata. It can be overridden for a collection by adding a mappingList into the oai_dc metadataFormat element in the collection's collectionConfig.xml file.
-        The mapping is in the form: <publicly supported metadata name>,<greenstone metadata name>, (<A>,<B>). B metadata from a document will be mapped to A. 
-        The first metadata name is mandatory; if there is no greenstone name following, then the first name will be looked for in the documents. 
-        -->
-	<mapping>dc:title,dc.Title</mapping>
-	<mapping>dc:creator,dc.Creator</mapping>
-	<mapping>dc:subject,dc.Subject</mapping>
-	<mapping>dc:description,dc.Description</mapping>
-	<mapping>dc:publisher,dc.Publisher</mapping>
-	<mapping>dc:contributor,dc.Contributor</mapping>
-	<mapping>dc:date,dc.Date</mapping>
-	<mapping>dc:type,dc.Type</mapping>
-	<mapping>dc:format,dc.Format</mapping>
-	<mapping>dc:identifier,dc.Identifier</mapping>
-	<mapping>dc:source,dc.Source</mapping>
-	<mapping>dc:language,dc.Language</mapping>
-	<mapping>dc:relation,dc.Relation</mapping>
-	<mapping>dc:coverage,dc.Coverage</mapping>
-	<mapping>dc:rights,dc.Rights</mapping>
-      </mappingList>
-    </metadataFormat>
-  </ListMetadataFormats>
-</OAIConfig>