Index: other-projects/nightly-tasks/diffcol/trunk/model-collect/METS/archives/HASH017c.dir/docmets.xml
===================================================================
--- other-projects/nightly-tasks/diffcol/trunk/model-collect/METS/archives/HASH017c.dir/docmets.xml	(revision 28812)
+++ other-projects/nightly-tasks/diffcol/trunk/model-collect/METS/archives/HASH017c.dir/docmets.xml	(revision 28926)
@@ -25,8 +25,8 @@
       <gsdl3:Metadata name="UTF8URL">http://html_files/boleyn.html</gsdl3:Metadata>
       <gsdl3:Metadata name="Identifier">HASH017c9afe86ea1866828ceb1b</gsdl3:Metadata>
-      <gsdl3:Metadata name="lastmodified">1391133405</gsdl3:Metadata>
-      <gsdl3:Metadata name="lastmodifieddate">20140131</gsdl3:Metadata>
-      <gsdl3:Metadata name="oailastmodified">1391133566</gsdl3:Metadata>
-      <gsdl3:Metadata name="oailastmodifieddate">20140131</gsdl3:Metadata>
+      <gsdl3:Metadata name="lastmodified">1395194700</gsdl3:Metadata>
+      <gsdl3:Metadata name="lastmodifieddate">20140319</gsdl3:Metadata>
+      <gsdl3:Metadata name="oailastmodified">1395194876</gsdl3:Metadata>
+      <gsdl3:Metadata name="oailastmodifieddate">20140319</gsdl3:Metadata>
       <gsdl3:Metadata name="assocfilepath">HASH017c.dir</gsdl3:Metadata>
       <gsdl3:Metadata name="gsdlassocfile">boleyncardinalbig.gif:image/gif:</gsdl3:Metadata>
Index: other-projects/nightly-tasks/diffcol/trunk/model-collect/METS/archives/HASH01c1.dir/docmets.xml
===================================================================
--- other-projects/nightly-tasks/diffcol/trunk/model-collect/METS/archives/HASH01c1.dir/docmets.xml	(revision 28812)
+++ other-projects/nightly-tasks/diffcol/trunk/model-collect/METS/archives/HASH01c1.dir/docmets.xml	(revision 28926)
@@ -25,8 +25,8 @@
       <gsdl3:Metadata name="UTF8URL">http://html_files/cleves.html</gsdl3:Metadata>
       <gsdl3:Metadata name="Identifier">HASH01c1e7e6aeea41090cb38bab</gsdl3:Metadata>
-      <gsdl3:Metadata name="lastmodified">1391133405</gsdl3:Metadata>
-      <gsdl3:Metadata name="lastmodifieddate">20140131</gsdl3:Metadata>
-      <gsdl3:Metadata name="oailastmodified">1391133566</gsdl3:Metadata>
-      <gsdl3:Metadata name="oailastmodifieddate">20140131</gsdl3:Metadata>
+      <gsdl3:Metadata name="lastmodified">1395194700</gsdl3:Metadata>
+      <gsdl3:Metadata name="lastmodifieddate">20140319</gsdl3:Metadata>
+      <gsdl3:Metadata name="oailastmodified">1395194876</gsdl3:Metadata>
+      <gsdl3:Metadata name="oailastmodifieddate">20140319</gsdl3:Metadata>
       <gsdl3:Metadata name="assocfilepath">HASH01c1.dir</gsdl3:Metadata>
       <gsdl3:Metadata name="gsdlassocfile">clevescardinal.gif:image/gif:</gsdl3:Metadata>
Index: other-projects/nightly-tasks/diffcol/trunk/model-collect/METS/archives/HASHea92.dir/docmets.xml
===================================================================
--- other-projects/nightly-tasks/diffcol/trunk/model-collect/METS/archives/HASHea92.dir/docmets.xml	(revision 28812)
+++ other-projects/nightly-tasks/diffcol/trunk/model-collect/METS/archives/HASHea92.dir/docmets.xml	(revision 28926)
@@ -25,8 +25,8 @@
       <gsdl3:Metadata name="UTF8URL">http://html_files/aragon.html</gsdl3:Metadata>
       <gsdl3:Metadata name="Identifier">HASHea9284af3b5d7ad3d4018b</gsdl3:Metadata>
-      <gsdl3:Metadata name="lastmodified">1391133405</gsdl3:Metadata>
-      <gsdl3:Metadata name="lastmodifieddate">20140131</gsdl3:Metadata>
-      <gsdl3:Metadata name="oailastmodified">1391133565</gsdl3:Metadata>
-      <gsdl3:Metadata name="oailastmodifieddate">20140131</gsdl3:Metadata>
+      <gsdl3:Metadata name="lastmodified">1395194700</gsdl3:Metadata>
+      <gsdl3:Metadata name="lastmodifieddate">20140319</gsdl3:Metadata>
+      <gsdl3:Metadata name="oailastmodified">1395194876</gsdl3:Metadata>
+      <gsdl3:Metadata name="oailastmodifieddate">20140319</gsdl3:Metadata>
       <gsdl3:Metadata name="assocfilepath">HASHea92.dir</gsdl3:Metadata>
       <gsdl3:Metadata name="gsdlassocfile">aragoncardinal.gif:image/gif:</gsdl3:Metadata>
Index: other-projects/nightly-tasks/diffcol/trunk/model-collect/METS/archives/rss-items.rdf
===================================================================
--- other-projects/nightly-tasks/diffcol/trunk/model-collect/METS/archives/rss-items.rdf	(revision 28812)
+++ other-projects/nightly-tasks/diffcol/trunk/model-collect/METS/archives/rss-items.rdf	(revision 28926)
@@ -1,12 +1,12 @@
 <item>
    <title></title>
-   <link>_httpdomain__httpcollection_/document/HASHea9284af3b5d7ad3d4018b</link>
+   <link>_httpdomainHtmlsafe__httpcollection_/document/HASHea9284af3b5d7ad3d4018b</link>
 </item>
 <item>
    <title></title>
-   <link>_httpdomain__httpcollection_/document/HASH017c9afe86ea1866828ceb1b</link>
+   <link>_httpdomainHtmlsafe__httpcollection_/document/HASH017c9afe86ea1866828ceb1b</link>
 </item>
 <item>
    <title></title>
-   <link>_httpdomain__httpcollection_/document/HASH01c1e7e6aeea41090cb38bab</link>
+   <link>_httpdomainHtmlsafe__httpcollection_/document/HASH01c1e7e6aeea41090cb38bab</link>
 </item>
Index: other-projects/nightly-tasks/diffcol/trunk/model-collect/METS/index/build.cfg
===================================================================
--- other-projects/nightly-tasks/diffcol/trunk/model-collect/METS/index/build.cfg	(revision 28812)
+++ other-projects/nightly-tasks/diffcol/trunk/model-collect/METS/index/build.cfg	(revision 28926)
@@ -1,5 +1,5 @@
-builddate	1391133567
+builddate	1395194878
 buildtype	mgpp
-earliestdatestamp	1391133565
+earliestdatestamp	1395194876
 indexfieldmap	text->TX	dc.Title,ex.dc.Title,Title->TI	Source->SO
 indexfields	text	dc.Title,ex.dc.Title,Title	Source
Index: other-projects/nightly-tasks/diffcol/trunk/model-collect/METS/index/rss-items.rdf
===================================================================
--- other-projects/nightly-tasks/diffcol/trunk/model-collect/METS/index/rss-items.rdf	(revision 28812)
+++ other-projects/nightly-tasks/diffcol/trunk/model-collect/METS/index/rss-items.rdf	(revision 28926)
@@ -1,12 +1,12 @@
 <item>
    <title></title>
-   <link>_httpdomain__httpcollection_/document/HASHea9284af3b5d7ad3d4018b</link>
+   <link>_httpdomainHtmlsafe__httpcollection_/document/HASHea9284af3b5d7ad3d4018b</link>
 </item>
 <item>
    <title></title>
-   <link>_httpdomain__httpcollection_/document/HASH017c9afe86ea1866828ceb1b</link>
+   <link>_httpdomainHtmlsafe__httpcollection_/document/HASH017c9afe86ea1866828ceb1b</link>
 </item>
 <item>
    <title></title>
-   <link>_httpdomain__httpcollection_/document/HASH01c1e7e6aeea41090cb38bab</link>
+   <link>_httpdomainHtmlsafe__httpcollection_/document/HASH01c1e7e6aeea41090cb38bab</link>
 </item>