Index: /documentation/trunk/tutorials/xml-source/tutorial_en.xml
===================================================================
--- /documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 28940)
+++ /documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 28941)
@@ -2423,5 +2423,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="0533e">To change the text that is displayed in the drop-down menus of the search form, go to the <AutoText key="glidict::CDM.GUI.SearchMetadata"/> section of the <AutoText key="glidict::GUI.Format"/> panel. Here you can change the display text for the indexes.</Text>
+<Text id="0533e">To change the text that is displayed in the drop-down menus of the search form, you would go to the <AutoText key="glidict::CDM.GUI.SearchMetadata"/> section of the <AutoText key="glidict::GUI.Format"/> panel. Here you can change the display text for the indexes.</Text>
 </NumberedItem>
 <Heading>
@@ -4674,5 +4674,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="0757">Now change to the <AutoText key="glidict::GUI.Create"/> panel, locate the options for the import process and set <AutoText text="saveas"/> to <AutoText text="METS"/>. Import options are not available unless you are in <AutoText key="glidict::Preferences.Mode.Expert"/> mode.</Text>
+<Text id="0757">Now change to the <AutoText key="glidict::GUI.Create"/> panel, locate the options for the import process and set <AutoText text="saveas"/> to <AutoText text="GreenstoneMETS"/>. Import options are not available unless you are in <AutoText key="glidict::Preferences.Mode.Expert"/> mode.</Text>
 </NumberedItem>
 <NumberedItem>
@@ -5343,5 +5343,5 @@
 	<Tab n="3"/>&lt;xsl:otherwise&gt;<br />
 		<Tab n="4"/>&lt;li class="login"&gt;<br />
-			<Tab n="5"/>&lt;a href="{$library_name}?a=p&amp;sa=login&amp;redirectURL={$library_name}%3Fa=p%26sa=home"&gt;Login<br/>
+			<Tab n="5"/>&lt;a href="{$library_name}?a=p&amp;amp;sa=login&amp;amp;redirectURL={$library_name}%3Fa=p%26sa=home"&gt;Login<br/>
 				<Tab n="6"/>&lt;xsl:attribute name="title"&gt;<br/>
 					<Tab n="7"/>&lt;xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'login_tip')"/&gt;<br/>
@@ -5357,5 +5357,5 @@
 <Text id="hp-24">Then, find the following section:</Text>
 <Format>
-&lt;li&gt;&lt;a href="?a=p&amp;sa=login&amp;redirectURL={$library_name}%3Fa=p%26sa=home"&gt;Login&lt;/a&gt;&lt;/li&gt;<br />
+&lt;li&gt;&lt;a href="?a=p&amp;amp;sa=login&amp;amp;redirectURL={$library_name}%3Fa=p%26sa=home"&gt;Login&lt;/a&gt;&lt;/li&gt;<br />
 &lt;li&gt;&lt;a href="{$library_name}/admin/AccountSettings?s1.username="&gt;Account Settings&lt;/a&gt;&lt;/li&gt;<br />
 &lt;li&gt;&lt;a href="{$library_name}/admin/AddUser"&gt;Register a new user&lt;/a&gt;&lt;/li&gt;<br />
@@ -5403,5 +5403,5 @@
 <Text id="dl-c2"><b>Interfaces</b> dictate the presentation -- e.g. the HTML, CSS, Javascript, etc. used to present the content. You can have multiple sites and interfaces. <br/><br/></Text>
 <Text id="dl-c3"><b>Libraries</b> combine content and presentation. To define a library, you select the site and the interface you want it to use. And, of course, you can have multiple libraries, and each site and interface can be used multiple times.  <br/><br/></Text>
-<Text id="dl-c4">In this tutorial, we will become familiar with <b>web.xml</b>(where libraries are defined), create a new site, add an interface, and define a new library.</Text>
+<Text id="dl-c4">In this tutorial, we will become familiar with <b>web.xml</b> (where libraries are defined), create a new site, add an interface, and define a new library.</Text>
 </Comment>
 <Heading>
@@ -5748,5 +5748,5 @@
 <NumberedItem>
 <Text id="ni2-06">Save <b>home.xsl</b> and refresh your web browser. You should no longer have an error. For every collection in your library, you should now see an image followed by the collection's name. In a moment, we will add in the Javascript that will turn these into a slider, but first, let's consider what the collSlider template is doing.</Text>
-<Text id="ni2-07">Basically, for every collection in your library (<Format>&lt;xsl:for-each select="./collectionList/collection"&gt;</Format>), it is creating a list item than includes an image and the collection's name, which links to the collection's about page. If the collection has a Home page image (the "smallicon"), this will be displayed. Otherwise a backup image (<i>default.jpg</i>, which is located in <Path>perrin &rarr; images</Path>) will be displayed. </Text>
+<Text id="ni2-07">Basically, for every collection in your library (<Format>&lt;xsl:for-each select="./collectionList/collection"&gt;</Format>), it is creating a list item that includes an image and the collection's name, which links to the collection's about page. If the collection has a Home page image (the "smallicon"), this will be displayed. Otherwise a backup image (<i>default.jpg</i>, which is located in <Path>perrin &rarr; images</Path>) will be displayed. </Text>
 </NumberedItem>
 <NumberedItem>
@@ -5841,5 +5841,5 @@
 </Format>
 <Comment>
-<Text id="ni2-14a">These templates are a more complicated, but a basic explanation follows (don't worry if you don't understand it). You can skip ahead to Step 9 if you'd like.</Text>
+<Text id="ni2-14a">These templates are more complicated, but a basic explanation follows (don't worry if you don't understand it). You can skip ahead to Step 9 if you'd like.</Text>
 </Comment>
 <Text id="ni2-14">First look at the collDescription template. It creates a header that links to the collection's about page (<Format>&lt;h2&gt;&lt;a href="{$library_name}/collection/{$collectionFolder}/page/about"&gt;&lt;xsl:value-of select="$collectionName"/&gt;&lt;/a&gt;&lt;/h2&gt;</Format>). Then, if there is an About page image for the collection, this is displayed. Finally, if the collection has a description (<Format>&lt;xsl:when test="$collDesc"&gt;</Format>), it will display this description. Otherwise, it will display the a generic sentence stating the collection's name and how many documents it contains.</Text>